# ----------------------------------------------------------------------
#  MAIN PROGRAM - generated by the Rappture Builder
# ----------------------------------------------------------------------
import Rappture
import sys
from math import *
import os
import re
import shutil
import stat

import Rappture
from Rappture.tools import getCommandOutput as RapptureExec

def getstdout(): # get the standard output of a mpi job
    cmd = 'find . -name "*.stdout" -print'
    fid = os.popen(cmd).readlines()
    if len(fid) >= 1:
        return 'Stdout is:\n'+open(fid[0][:-1]).read()
    else:
        return 'Error: no returned stdout file\n'


def getstderr(): # get the standard error of a mpi job
    cmd = 'find . -name "*.stderr" -print'
    fid = os.popen(cmd).readlines()
    if len(fid) >= 1:
        return 'Stderr is:\n'+open(fid[0][:-1]).read()
    else:
        return ''

exitStatus = 0
# open the XML file containing the run parameters
io = Rappture.library(sys.argv[1])

#########################################################
# Get input values from Rappture
#########################################################

# get input value for input.phase(mode_option).choice(option)
option = io.get('input.phase(mode_option).choice(option).current')

# get input value for input.phase(parameter).group(load).string(deck)
deck = io.get('input.phase(parameter).group(load).string(deck).current')

# get input value for input.phase(parameter).group(layout).group(pic).image(image)
# returns base64-encoded image data
image = io.get('input.phase(parameter).group(layout).group(pic).image(image).current')

# get input value for input.phase(parameter).group(layout).group(pic).image(image2)
# returns base64-encoded image data
image2 = io.get('input.phase(parameter).group(layout).group(pic).image(image2).current')

# get input value for input.phase(parameter).group(layout).group(pic).image(image3)
# returns base64-encoded image data
image3 = io.get('input.phase(parameter).group(layout).group(pic).image(image3).current')

# get input value for input.phase(parameter).group(layout).group(pic).image(image4)
# returns base64-encoded image data
image4 = io.get('input.phase(parameter).group(layout).group(pic).image(image4).current')

# get input value for input.phase(parameter).group(layout).group(pic).image(image5)
# returns base64-encoded image data
image5 = io.get('input.phase(parameter).group(layout).group(pic).image(image5).current')

# get input value for input.phase(parameter).group(layout).group(pic).image(image6)
# returns base64-encoded image data
image6 = io.get('input.phase(parameter).group(layout).group(pic).image(image6).current')

# get input value for input.phase(parameter).group(layout).group(pic).image(image7)
# returns base64-encoded image data
image7 = io.get('input.phase(parameter).group(layout).group(pic).image(image7).current')

# get input value for input.phase(parameter).group(load).group(options).integer(nidentical)
nidentical = int(io.get('input.phase(parameter).group(load).group(options).integer(nidentical).current')

# get input value for input.phase(parameter).group(load).group(options).integer(ncpu)
nidentical = int(io.get('input.phase(parameter).group(load).group(options).integer(nidentical).current')

# get input value for input.phase(parameter).group(load).group(options).integer(ncpu)
ncpu = int(io.get('input.phase(parameter).group(load).group(options).integer(ncpu).current'))

# take the product
ncpu = ncpu * nidentical

# get input value for input.phase(parameter).group(load).group(options).number(walltime) and convert to min
walltime = io.get('input.phase(parameter).group(load).group(options).number(walltime).current')
walltime = int(float(Rappture.Units.convert(walltime, to="min", units="off")))

# get input value for input.phase(parameter).group(layout).group(tab).group(feature)
dimension = io.get('input.phase(parameter).group(layout).group(tab).group(feature).choice(dimension).current')

# get input value for input.phase(parameter).group(layout).group(tab).group(feature).boolean(lattice)
# returns value as string "yes" or "no"
lattice = io.get('input.phase(parameter).group(layout).group(tab).group(feature).boolean(lattice).current') == 'yes'

# get input value for input.phase(parameter).group(layout).group(tab).group(feature).number(const)
const = float(io.get('input.phase(parameter).group(layout).group(tab).group(feature).number(const).current'))

# get input value for input.phase(parameter).group(layout).group(tab).group(feature).boolean(wavelength)
# returns value as string "yes" or "no"
wavelength = io.get('input.phase(parameter).group(layout).group(tab).group(feature).boolean(wavelength).current') == 'yes'

# get input value for input.phase(parameter).group(layout).group(tab).group(feature).number(min_wave)
min_wave = float(io.get('input.phase(parameter).group(layout).group(tab).group(feature).number(min_wave).current'))

# get input value for input.phase(parameter).group(layout).group(tab).group(feature).number(max_wave)
max_wave = float(io.get('input.phase(parameter).group(layout).group(tab).group(feature).number(max_wave).current'))

# get input value for input.phase(parameter).group(layout).group(tab).group(feature).integer(nfreq)
nfreq = int(io.get('input.phase(parameter).group(layout).group(tab).group(feature).integer(nfreq).current'))

# get input value for input.phase(parameter).group(layout).group(tab).group(feature).number(arthickness)
arthickness = float(io.get('input.phase(parameter).group(layout).group(tab).group(feature).number(arthickness).current'))

# get input value for input.phase(parameter).group(layout).group(tab).group(feature).number(siliconthickness)
siliconthickness = float(io.get('input.phase(parameter).group(layout).group(tab).group(feature).number(siliconthickness).current'))

# get input value for input.phase(parameter).group(layout).group(tab).group(feature).number(arindex)
arindex = float(io.get('input.phase(parameter).group(layout).group(tab).group(feature).number(arindex).current'))

# get input value for input.phase(parameter).group(layout).group(tab).group(feature).boolean(textured)
# returns value as string "yes" or "no"
textured = io.get('input.phase(parameter).group(layout).group(tab).group(feature).boolean(textured).current') == 'yes'

# get input value for input.phase(parameter).group(layout).group(tab).group(feature).boolean(inverseopal)
# returns value as string "yes" or "no"
inverseopal = io.get('input.phase(parameter).group(layout).group(tab).group(feature).boolean(inverseopal).current') == 'yes'

# get input value for input.phase(parameter).group(layout).group(tab).group(feature).boolean(burriedoxide)
# returns value as string "yes" or "no"
burriedoxide = io.get('input.phase(parameter).group(layout).group(tab).group(feature).boolean(burriedoxide).current') == 'yes'

# get input value for input.phase(parameter).group(layout).group(tab).group(feature).boolean(BR)
# returns value as string "yes" or "no"
BR = io.get('input.phase(parameter).group(layout).group(tab).group(feature).boolean(BR).current') == 'yes'

# get input value for input.phase(parameter).group(layout).group(tab).group(feature).note(note)
note = io.get('input.phase(parameter).group(layout).group(tab).group(feature).note(note).current')

# get input value for input.phase(parameter).group(layout).group(tab).group(text).number(text_thickness)
text_thickness = float(io.get('input.phase(parameter).group(layout).group(tab).group(text).number(text_thickness).current'))

# get input value for input.phase(parameter).group(layout).group(tab).group(text).number(width)
width = float(io.get('input.phase(parameter).group(layout).group(tab).group(text).number(width).current'))

# get input value for input.phase(parameter).group(layout).group(tab).group(opal).number(rad)
rad = float(io.get('input.phase(parameter).group(layout).group(tab).group(opal).number(rad).current'))

# get input value for input.phase(parameter).group(layout).group(tab).group(opal).number(sphereeps)
sphereeps = float(io.get('input.phase(parameter).group(layout).group(tab).group(opal).number(sphereeps).current'))

# get input value for input.phase(parameter).group(layout).group(tab).group(opal).integer(layers)
layers = int(io.get('input.phase(parameter).group(layout).group(tab).group(opal).integer(layers).current'))

# get input value for input.phase(parameter).group(layout).group(tab).group(b_oxide).number(thickness)
thickness = float(io.get('input.phase(parameter).group(layout).group(tab).group(b_oxide).number(thickness).current'))

# get input value for input.phase(parameter).group(layout).group(tab).group(b_oxide).number(refr_index)
refr_index = float(io.get('input.phase(parameter).group(layout).group(tab).group(b_oxide).number(refr_index).current'))

# get input value for input.phase(parameter).group(layout).group(tab).group(backrefl).choice(material)
material = io.get('input.phase(parameter).group(layout).group(tab).group(backrefl).choice(material).current')

# get input value for input.phase(parameter).group(layout).group(tab).group(backrefl).boolean(grating)
# returns value as string "yes" or "no"
grating = io.get('input.phase(parameter).group(layout).group(tab).group(backrefl).boolean(grating).current') == 'yes'

# get input value for input.phase(parameter).group(layout).group(tab).group(backrefl).number(grat_thickness)
grat_thickness = float(io.get('input.phase(parameter).group(layout).group(tab).group(backrefl).number(grat_thickness).current'))

# get input value for input.phase(parameter).group(layout).group(tab).group(backrefl).number(gratingperiod)
gratingperiod = float(io.get('input.phase(parameter).group(layout).group(tab).group(backrefl).number(gratingperiod).current'))

# get input value for input.phase(parameter).group(layout).group(tab).group(backrefl).number(dutycycle)
dutycycle = float(io.get('input.phase(parameter).group(layout).group(tab).group(backrefl).number(dutycycle).current'))


#########################################################
#  Add your code here for the main body of your program
#########################################################

if option == "1":
   deck = ''';solarcell2d-planar+textured.ctl
;created by Peter Bermel on 4 September 2008

;target lambda=2.5a=800 nm, so a=320 nm
;could set a=540 nm for inverse opal calculation
(define-param a 0.5) ; periodicity in microns
(define-param fcen 1.041666667)
(define-param df 1.25)
(define-param nfreq 201)
(define-param textured false)
(define-param deterministic? true)
(define-param no-back-reflector? true)
(define-param siliconthickness 4.0)
(define-param arthickness 0)
(define-param arindex 1.92)
(define-param randomthickness 0.5)
(define-param gratingthickness 0.0)
(define-param nsilicon 3.679)
(define-param ksilicon 0.00406)
(define-param naluminum 2.80)
(define-param kaluminum 8.07513540648729)
(define-param nsilver 0.142628)
(define-param ksilver 5.297116)
(define-param yperiods 4)
(define-param zperiods 4)
(define-param wid 50)
(define-param reflector-mat-num 0)
  ; 0 = perfect metal; 1=silver; 2=aluminum
(define-param nlayers 0) ; cannot be more than 10
(define-param periodinunitsofa 1)
(define-param boxt 0) ; buried oxide thickness (in units of a)
(define-param boxn 1.46) ; buried oxide refractive index
(define-param is3d? true) ; if false, then run 2D simulation
(set-param! resolution 40)
(define-param rad 0.5)
(define-param sphereeps 1) 
  ; 1 = air spheres (presumably embedded in high dielectric)
(define spheremat (make dielectric (epsilon sphereeps)))
; define different spheres
(define A (make sphere (radius rad) (center 0)
                       (material spheremat)))
(define B (make sphere (radius rad) (center 0 (/ (sqrt 3)))
		       (material spheremat)))
(define C (make sphere (radius rad) (center 0 (/ (sqrt 12)) (/ 2))
		       (material spheremat)))
(define layers (list A B C A B C A B C A))

(define (rev l)
  (if (null? (cdr l))
      l
      (append (rev (cdr l)) (list (car l)))))

(define (choplayers layerlist cnlayers)
  (if (> cnlayers 0)
      (choplayers (rev (cdr (rev layerlist))) (- cnlayers 1))
      layerlist))

(if (> nlayers 0)
  (set! layers (choplayers layers (- 10 nlayers)))
  (set! layers '()))

(print layers)

  ; this list is NOT repeated periodically -- some examples:
  ; hcp = ABABABAB...
  ; fcc = ABCABCABC...
  ; 4H (dhcp) = ABCBABCBABCB...
; only use the following when no layers are of type C:
;(set! symmetries (list (make mirror-sym (direction Y))))
(define backgroundeps (* nsilicon nsilicon)) ; background for inverse PhC structure

(set! eps-averaging? false)
(define mylambda (/ fcen))
(define pmlthickness 2.0)
(define metalthickness 0.5)
(define decayf 1e-5)

;stuff below here should not have to be changed, usually
(define pitch (sqrt (/ 2 3)))
(define bufferthickness (/ mylambda 2))
(if (> nlayers 0)
  (define latticeheight (+ (* 2 rad) (* pitch (- nlayers 1))))
  (define latticeheight 0))
(define nx (+ (* 2 (+ pmlthickness bufferthickness)) arthickness siliconthickness metalthickness boxt latticeheight))
(define xsrc (+ (/ nx -2) pmlthickness (/ bufferthickness 2)))
(define xar (+ xsrc (/ (+ bufferthickness arthickness) 2)))
(define xsilicon (+ xar (/ (+ arthickness siliconthickness) 2)))
(define xrandom (- xsilicon (/ siliconthickness 2))) 
(define xmetal (- (/ nx 2) (+ bufferthickness pmlthickness (/ metalthickness 2))))
(define xgrating (- xmetal (/ (+ gratingthickness metalthickness) 2)))
(define xrefl (- xsrc (/ bufferthickness 4)))
(define xtrans (+ xmetal (/ (+ metalthickness bufferthickness) 2)))
(define xphc 0) ; will need to be fixed
(define xbox 0) ; will need to be fixed
(define sigmasilicon (/ (* 4 pi fcen nsilicon ksilicon) (- (* nsilicon nsilicon) (* ksilicon ksilicon))))
(define sigmaaluminum (/ (* 4 pi fcen naluminum kaluminum) (- (* naluminum naluminum) (* kaluminum kaluminum))))
(define sigmasilver (/ (* 4 pi fcen nsilver ksilver) (- (* nsilver nsilver) (* ksilver ksilver))))
(define sy (* periodinunitsofa yperiods))
(define-param nrandom (/ (* sy a 1000) wid))
(if is3d?
  (define sz zperiods)
  (define sz sy))
(define first-layer-depth (- (+ xphc rad) (/ latticeheight 2)))

(if is3d?
  (set! geometry-lattice (make lattice (size nx sy sz)))
  (set! geometry-lattice (make lattice (size nx sy no-size))))
(define ar_m (make medium (index arindex)))
(define silicon_m (make medium (index nsilicon) (D-conductivity sigmasilicon)))

(define-param eps-inf 1.01)
(define-param omegaT0 0.0001)
(define-param omegaP0 (* 6.6793 a))
(define-param g0 (* a 0.0387))
(define-param deps0 (expt (/ omegaP0 omegaT0) 2))

(define-param omegaT1 (* a 0.6581))
(define-param omegaP1 (* a 1.8525))
(define-param g1 (* a 3.1338))
(define-param deps1 (expt (/ omegaP1 omegaT1) 2))

(define-param omegaT2 (* a 3.6137))
(define-param omegaP2 (* a 2.5587))
(define-param g2  (* a 0.3645))
(define-param deps2 (expt (/ omegaP2 omegaT2) 2))

;(define-param omegaT3 (* a 2.8259))
;(define-param omegaP3 (* a 8.5034))
;(define-param g3 (* a 1.2708))
;(define-param deps3 (expt (/ omegaP3 omegaT3) 2))

(define silver (make dielectric (epsilon eps-inf) (polarizations 
                  (make polarizability (omega omegaT0) (gamma g0) (sigma deps0))
                  (make polarizability (omega omegaT1) (gamma g1) (sigma deps1))
                  (make polarizability (omega omegaT2) (gamma g2) (sigma deps2))
                  ;(make polarizability (omega omegaT3) (gamma g3) (sigma deps3))
)))

(define-param omegaT0_alum 0.0001)
(define-param omegaP0_alum (* 8.7366 a))
(define-param g0_alum (* a 0.0379))
(define-param deps0_alum (expt (/ omegaP0_alum omegaT0_alum) 2))

(define-param omegaT1_alum (* a 0.1306))
(define-param omegaP1_alum (* a 5.7558))
(define-param g1_alum (* a 0.2685))
(define-param deps1_alum (expt (/ omegaP1_alum omegaT1_alum) 2))

(define-param omegaT2_alum (* a 1.2452))
(define-param omegaP2_alum (* a 2.7013))
(define-param g2_alum  (* a 0.2516))
(define-param deps2_alum (expt (/ omegaP2_alum omegaT2_alum) 2))

(define-param omegaT3_alum (* a 1.4581))
(define-param omegaP3_alum (* a 4.9220))
(define-param g3_alum (* a 1.0895))
(define-param deps3_alum (expt (/ omegaP3_alum omegaT3_alum) 2))

(define aluminum (make dielectric (epsilon eps-inf) (polarizations 
                  (make polarizability (omega omegaT0_alum) (gamma g0_alum) (sigma deps0_alum))
                  (make polarizability (omega omegaT1_alum) (gamma g1_alum) (sigma deps1_alum))
                  (make polarizability (omega omegaT2_alum) (gamma g2_alum) (sigma deps2_alum))
                  (make polarizability (omega omegaT3_alum) (gamma g3_alum) (sigma deps3_alum))
)))



(if (= reflector-mat-num 0)
  (define backreflmat metal)
  (if (= reflector-mat-num 1)
    (define backreflmat silver)
    (define backreflmat aluminum)))

(if (not deterministic?)
    (let ((time (gettimeofday)))
      (set! *random-state*
            (seed->random-state (+ (car time)
                                   (cdr time))))))
(define-param rand-init? true)
;(define-param kind U-SUM)
(define-param r 0.1)

(define (makerandomblocks curr tot)
  (append (list (make block 
                  (center (- xrandom (/ randomthickness 2)) (/ (* sy (- (* 2 curr) (+ tot 1))) (* 2 tot)))
                  (material air)
	          (size (* 2 randomthickness (random:uniform)) (/ sy tot) sz)))
          (if (> curr 1) (makerandomblocks (- curr 1) tot) (list ))))

(define currsphere A)
(define shftsphere A)

(define (add-layers mylist height)
  (if (zero? (length mylist))
    (print "Finished running through my layers list.\n")
    (begin
      (set! currsphere (car mylist))
      (set! shftsphere (shift-geometric-object currsphere (vector3 height)))
      (set! geometry (append geometry 
        ; was: (list shftsphere)
        (geometric-objects-duplicates (vector3 0 (/ (sqrt 3) 2) 0.5) -1 1 
	   (geometric-object-duplicates (vector3 0 (/ (sqrt 3) 2) -0.5) -1 1 shftsphere))))
      (add-layers (cdr mylist) (+ height pitch)))))

(if is3d?
  (set! sources (list (make source
                        (src (make gaussian-src (frequency fcen) (fwidth df)))
                        (component Ez) (size 0 sy sz) (center xsrc))))
  (set! sources (list (make source
                        (src (make gaussian-src (frequency fcen) (fwidth df)))
                        (component Ez) (size 0 sy) (center xsrc)))))

(define k-point (vector3 0 0 0))
; (set! ensure-periodicity true)
(set! pml-layers (list (make pml (direction X) (thickness pmlthickness))))

(define trans (add-flux fcen df nfreq
  (make flux-region (center xtrans 0 0) (size 0 sy sz))))
(define refl (add-flux fcen df nfreq
  (make flux-region (center xrefl 0 0) (size 0 sy sz))))
(define refl-flux-file (string-append "refl-flux-" (number->string yperiods) "periods-w" (number->string fcen) "-dw" (number->string df)))
(print "Defined flux regions.\n")

; homogeneous run
(run-until (stop-when-fields-decayed 20 Ez (vector3 xsilicon) decayf))
(display-fluxes trans refl)
(save-flux "refl-flux.h5" refl)
(reset-meep)

(if is3d?
  (set! geometry-lattice (make lattice (size nx sy sz)))
  (set! geometry-lattice (make lattice (size nx sy no-size))))

(define k-point (vector3 0 0 0))
(set! pml-layers (list (make pml (direction X) (thickness pmlthickness))))

(if is3d?
  (set! sources (list (make source
                        (src (make gaussian-src (frequency fcen) (fwidth df)))
                        (component Ez) (size 0 sy sz) (center xsrc))))
  (set! sources (list (make source
                        (src (make gaussian-src (frequency fcen) (fwidth df)))
                        (component Ez) (size 0 sy) (center xsrc)))))


; (restart-fields)
; (reset-meep)
; (scale-flux-fields -1 refl)
; (scale-flux-fields 0 trans)

; non-homogeneous run
;set non-homogeneous geometry

(set! geometry (list (make block (center xar) (material ar_m)
                           (size arthickness sy sz))
                        (make block (center xsilicon) (material silicon_m)
                           (size siliconthickness sy sz))))
(if (not no-back-reflector?)
     (set! geometry (append geometry 
                 (list (make block 
                        (center xmetal) (material backreflmat)
		        (size metalthickness sy sz)))
                 (geometric-object-duplicates (vector3 0 periodinunitsofa 0) 0 (- yperiods 1) 
                       (make block (center xgrating (+ 0.5 (/ sy -2)))
                        (material backreflmat)
			(size gratingthickness 0.5 sz))))))
(if textured
       (set! geometry (append geometry (list (make block (material silicon_m)
                         (center xrandom)
			 (size randomthickness sy sz)))
                      (makerandomblocks nrandom nrandom))))

(if (> boxt 0)
  (set! geometry (append geometry (list (make block (center xbox 0 0)
    (size boxt sy sz) (material (make medium (index boxn))))))))

(if (> nlayers 0)
 (begin
   (set! geometry (append geometry (list (make block (center xphc 0 0) 
         (size latticeheight sy sz)
         (material (make dielectric (epsilon backgroundeps)))))))
  (add-layers layers first-layer-depth)))


(define trans (add-flux fcen df nfreq
  (make flux-region (center xtrans 0 0) (size 0 sy sz))))
(define refl (add-flux fcen df nfreq
  (make flux-region (center xrefl 0 0) (size 0 sy sz))))

(load-minus-flux "refl-flux.h5" refl)

(run-until (stop-when-fields-decayed 20 Ez (vector3 xsilicon) decayf)
  (at-beginning output-epsilon)
  (before-time 400 (at-every 40 output-efield-z)))

(display-fluxes trans refl)
'''

   deck = deck.replace("nfreq 201","nfreq " + str(nfreq))
   deck = deck.replace("siliconthickness 4.0","siliconthickness " + str(float(siliconthickness)/const))
   deck = deck.replace("arthickness 0","arthickness " + str(float(arthickness)/const))
   deck = deck.replace("arindex 1.92","arindex " + str(arindex))

   if dimension == "1":
      deck = deck.replace("is3d? true","is3d? false")       

   if lattice == True:
      deck = deck.replace("a 0.5","a " + str(float(const)/1000))

   if wavelength == True:
      fmin = float(const) / max_wave
      fmax = float(const) / min_wave
      fcen = 0.5 * (fmin + fmax)
      df = fmax - fmin
      deck = deck.replace("fcen 1.041666667","fcen " + str(fcen))
      deck = deck.replace("df 1.25","df " + str(df))

     
   if textured == True:
      deck = deck.replace("textured false","textured true")
      deck = deck.replace("deterministic? true","deterministic? false")
      deck = deck.replace("randomthickness 0.5","randomthickness " + str(float(text_thickness)/const))
      deck = deck.replace("wid 50","wid " + str(width))

   if inverseopal == True:
      deck = deck.replace("define-param nlayers 0","define-param nlayers " + str(layers))
      deck = deck.replace("rad 0.5","rad " + str(float(rad)/const))
      deck = deck.replace("sphereeps 1","sphereeps " + str(sphereeps))

   if burriedoxide == True:
      deck = deck.replace("define-param boxt 0","define-param boxt " + str(float(thickness)/const))
      deck = deck.replace("boxn 1.46","boxn " + str(refr_index))

   if BR == True:
      deck = deck.replace("no-back-reflector? true","no-back-reflector? false")
      if material == "2":
         deck = deck.replace("reflector-mat-num 0","reflector-mat-num 2")
      if material == "3":
         deck = deck.replace("reflector-mat-num 0","reflector-mat-num 1")           
      if grating == True:
         deck = deck.replace("gratingthickness 0.0","gratingthickness " + str(float(grat_thickness)/const))
         deck = deck.replace("periodinunitsofa 1","periodinunitsofa " + str(float(gratingperiod)/const))
         deck = deck.replace("size gratingthickness 0.5 sz","size gratingthickness " + str(dutycycle) + " sz")


displayFluxes = re.search(".*display-fluxes (.*)\)",deck)
if displayFluxes:
   fluxTitles = displayFluxes.group(1).split()

# create the directory where output should be placed
re_driverNum  = re.compile(r'[0-9]+')
driverNum = re_driverNum.search(os.path.split(sys.argv[1])[1]).group()
resultDirName = os.path.join(os.getcwd(),driverNum)
if os.path.exists(resultDirName):
   shutil.rmtree(resultDirName,True)
os.mkdir(resultDirName)

wd = os.getcwd()
os.chdir(resultDirName)

f=open('run.ctl','w')
f.write(deck)
f.close()

if ncpu > 1:
   if   ncpu > 48:
      venue = 'rcac-ncn-par'
   elif walltime > 120:
      venue = 'rcac-ncn-par'
   elif ncpu*walltime > 3840:
# 32*120
      venue = 'rcac-ncn-par'
   else:
      venue = 'rcac-ncn-hub'

   submitScriptName = 'submit_meep.sh'
   submitScript     = """#!/bin/sh

trap cleanup HUP INT QUIT ABRT TERM

cleanup()
{
   echo "Abnormal termination by signal"
   kill -s TERM `jobs -p`
}

"""

   submitScript += "submit -v %s -n %s -w %s \\\n" % (venue,ncpu,walltime)
   submitScript += "  -r %s  meep-1.2-mpi run.ctl &\n" % (nidentical)
   submitScript += "wait %1\n"
   submitScript += "exit $?\n"

   submitScriptPath = os.path.join(resultDirName,submitScriptName)
   f = open(submitScriptPath, 'w')
   f.write(submitScript)
   f.close()
   os.chmod(submitScriptPath,stat.S_IRWXU|stat.S_IRGRP|stat.S_IXGRP|stat.S_IROTH|stat.S_IXOTH)

   exitStatus,submitOut,runerr = RapptureExec([submitScriptPath],True)
   runout = getstdout()
   runerr += getstderr()
else:
   exitStatus,runout,runerr = RapptureExec(["meep1","run.ctl"],True)


#########################################################
# Save output values back to Rappture
#########################################################

io.put('output.string(runout).current',runout)
io.put('output.string(runout).about.label','Output')
fpOut = open('run.stdout','w')
fpOut.write(runout)
fpOut.close()

if runerr != '':
    io.put('output.string(runerr).current',runerr)
    io.put('output.string(runerr).about.label','Error')
    fpErr = open('run.stderr','w')
    fpErr.write(runerr)
    fpErr.close()

Freq = 0
if not exitStatus:
    fluxData = ""
    for line in runout.splitlines(True):
        if re.match("^flux[0-9]*:,",line):
            fluxData += line
    if fluxData != "":
        fpFlux = open('fluxdata.csv','w')
        fpFlux.write(fluxData)
        fpFlux.close()

#       io.put('output.string(fluxdata).current',fluxData)
#       io.put('output.string(fluxdata).about.label','Flux Data')

        line = fluxData.splitlines()[0]
        nFields = line.count(',')
        curveData = {}
        curveData1 = {}
	curveData2 = {}
        for field in xrange(nFields):
            curveData[field] = ""
            curveData1[field] = ""
            curveData2[field] = ""
        for line in fluxData.splitlines():
            fields = line.split(',')
	    if re.match("^flux1:,",line):
               fields1 = line.split(',')
	       Freq += 1
	    else:
	       fields2 = line.split(',')
            for field in xrange(nFields):
                curveData[field] += "%s %s\n" % (float(const)/float(fields[1]),fields[1+field])
		if fields1:
                   curveData1[field] += "%s %s\n" % (float(const)/float(fields1[1]),fields1[1+field])
                elif fields2:
		   curveData2[field] += "%s %s\n" % (float(const)/float(fields2[1]),fields2[1+field])
	    if fields1:
	       fields1 = []
	    elif fields2:
	       fields2 = []
        trans1 = curveData1[1].split()
        trans2 = curveData2[1].split()
        refl1 = curveData1[2].split()
        refl2 = curveData2[2].split()
        for y in xrange(Freq):
            trans1[2*y+1] = str(float(trans2[2*y+1])/float(trans1[2*y+1]))
            refl1[2*y+1] = str(float(refl2[2*y+1])/float(refl1[2*y+1]))
            trans2[2*y+1] = str(1 - float(trans1[2*y+1]) - float(refl1[2*y+1]))
        curveData1[1] = " ".join(trans1)
        curveData1[2] = " ".join(refl1)
        curveData2[1] = " ".join(trans2)
        	
        for field in xrange(1,nFields):
            fluxPath = 'output.curve(flux%d)' % (field)
            io.put(fluxPath + '.about.label',fluxTitles[field-1])
            io.put(fluxPath + '.xaxis.label','Wavelength (nm)')
            io.put(fluxPath + '.yaxis.label',fluxTitles[field-1])
            io.put(fluxPath + '.component.xy',curveData[field])

        fluxPath = 'output.curve(flux3)' 
        io.put(fluxPath + '.about.label','trans quotient')
        io.put(fluxPath + '.xaxis.label','Wavelength (nm)')
        io.put(fluxPath + '.yaxis.label','trans quotient')
        io.put(fluxPath + '.component.xy',curveData1[1])

        fluxPath = 'output.curve(flux4)' 
        io.put(fluxPath + '.about.label','refl quotient')
        io.put(fluxPath + '.xaxis.label','Wavelength (nm)')
        io.put(fluxPath + '.yaxis.label','refl quotient')
        io.put(fluxPath + '.component.xy',curveData1[2])

        fluxPath = 'output.curve(flux5)' 
        io.put(fluxPath + '.about.label','absorption')
        io.put(fluxPath + '.xaxis.label','Wavelength (nm)')
        io.put(fluxPath + '.yaxis.label','loss')
        io.put(fluxPath + '.component.xy',curveData2[1])



    cmd = 'find . -name "*.h5" -print'
    h5files = os.popen(cmd).readlines()
    h5files.sort()
    io.put('output.sequence(outs).about.label','Animation')
    io.put('output.sequence(outs).index.label','Frame')
    index = 0
    for h5file in h5files:
       h5lsStatus,h5lsOut,h5lsErr = RapptureExec(["h5ls","%s" % (h5file[:-1])])
       if h5lsStatus == 0:
          is2D = True
          h5lsOut = h5lsOut.strip()
          for dataset in h5lsOut.split('\n'):
             dimensions = re.search(".*{(.*)}.*",dataset)
             if dimensions:
                if dimensions.group(1).count(',') != 1:
                   is2D = False
             else:
                is2D = False

          if is2D:
             if re.match(".*-eps-.*",h5file):
	        h5pngStatus,h5pngOut,h5pngErr = RapptureExec(["h5topng","-m","1","-M","20","%s" % (h5file[:-1])])
                if h5pngStatus == 0:
                   validImage = False
                   h5png = "%s.png" % (h5file[2:-4])
                   pngStatus,pngOut,pngErr = RapptureExec(["file","%s" % (h5png)])
                   if pngStatus == 0:
                      dimensions = re.search(".* ([0-9]+) x ([0-9]+),.*",pngOut)
                      if dimensions:
                         if int(dimensions.group(1)) > 1 and int(dimensions.group(2)) > 1:
                            # remove leading ./ and trailing .png^M
                            io.put('output.image(%s).about.label' % (h5png[:-4]),h5png[:-4])
                            io.put('output.image(%s).current' % (h5png[:-4]),h5png,type='file', compress=True)
                            validImage = True

                   if not validImage:
                      if os.path.exists("%s.png" % (h5file[:-4])):
                         os.remove("%s.png" % (h5file[:-4]))

	     else:
                h5pngStatus,h5pngOut,h5pngErr = RapptureExec(["h5topng","-v","-Z","-c","bluered","%s" % (h5file[:-1])])
                if h5pngStatus == 0:
                   validImage = False
                   h5png = "%s.png" % (h5file[2:-4])
                   pngStatus,pngOut,pngErr = RapptureExec(["file","%s" % (h5png)])
                   if pngStatus == 0:
                      dimensions = re.search(".* ([0-9]+) x ([0-9]+),.*",pngOut)
                      if dimensions:
                         if int(dimensions.group(1)) > 1 and int(dimensions.group(2)) > 1:
                            # remove leading ./ and trailing .png^M
   			    index = index + 1
   			    io.put('output.sequence(outs).element(%d).index' % (index-1),index)
   			    io.put('output.sequence(outs).element(%d).image.current' % (index-1),h5png,type='file', compress=True)
                            validImage = True

                   if not validImage:
                      if os.path.exists("%s.png" % (h5file[:-4])):
                         os.remove("%s.png" % (h5file[:-4]))

          else:
             if re.match(".*-eps-.*",h5file):
	        h5pngStatus,h5pngOut,h5pngErr = RapptureExec(["h5topng","-0y","-15","-m","1","-M","20","%s" % (h5file[:-1])])
                if h5pngStatus == 0:
                   validImage = False
                   h5png = "%s.png" % (h5file[2:-4])
                   pngStatus,pngOut,pngErr = RapptureExec(["file","%s" % (h5png)])
                   if pngStatus == 0:
                      dimensions = re.search(".* ([0-9]+) x ([0-9]+),.*",pngOut)
                      if dimensions:
                         if int(dimensions.group(1)) > 1 and int(dimensions.group(2)) > 1:
                            # remove leading ./ and trailing .png^M
                            io.put('output.image(%s).about.label' % (h5png[:-4]),h5png[:-4])
                            io.put('output.image(%s).current' % (h5png[:-4]),h5png,type='file', compress=True)
                            validImage = True

                   if not validImage:
                      if os.path.exists("%s.png" % (h5file[:-4])):
                         os.remove("%s.png" % (h5file[:-4]))

	     else:
                h5pngStatus,h5pngOut,h5pngErr = RapptureExec(["h5topng","-0y","-15","-Z","-c","bluered","%s" % (h5file[:-1])])
                if h5pngStatus == 0:
                   validImage = False
                   h5png = "%s.png" % (h5file[2:-4])
                   pngStatus,pngOut,pngErr = RapptureExec(["file","%s" % (h5png)])
                   if pngStatus == 0:
                      dimensions = re.search(".* ([0-9]+) x ([0-9]+),.*",pngOut)
                      if dimensions:
                         if int(dimensions.group(1)) > 1 and int(dimensions.group(2)) > 1:
                            # remove leading ./ and trailing .png^M
   			    index = index + 1
   			    io.put('output.sequence(outs).element(%d).index' % (index-1),index)
   			    io.put('output.sequence(outs).element(%d).image.current' % (index-1),h5png,type='file', compress=True)
                            validImage = True

                   if not validImage:
                      if os.path.exists("%s.png" % (h5file[:-4])):
                         os.remove("%s.png" % (h5file[:-4]))


io.put('output.string(deck).current',deck)
io.put('output.string(deck).about.label','Input')

cmd = 'tar cfz meepresults.tar.gz ./run.ctl'
allFiles = os.listdir(resultDirName)
for fileType in 'stdout','stderr','h5','png','csv':
   reFiles = re.compile('.*.%s$' % (fileType))
   matchingFiles = filter(reFiles.search,allFiles)
   if len(matchingFiles) > 0:
      cmd += ' ./*.' + fileType

tarout = os.popen(cmd).readlines()
io.put('output.string(tarball).about.label','meepresults.tar.gz')
io.put('output.string(tarball).current','meepresults.tar.gz',type='file',compress=True)

os.chdir(wd)
shutil.rmtree(resultDirName,True)

# show submission errors to user as stdout/err log.
exitStatus = 0
io.result(exitStatus)
sys.exit(exitStatus)

